import express, { Application } from "express";
import { ApolloServer, gql } from "apollo-server-express";
import cors from "cors";

const app: Application = express();
app.use(cors());

const typeDefs = gql`
  type Query {
    login(email: String!, password: String!): LoginUnion!
  }

  union LoginUnion = Login | Error

  type Error {
    error: Boolean!
    message: String!
  }

  type Login {
    id: ID!
    name: String!
    email: String!
  }
`;

const resolvers = {
  Query: {
    login: (parent: void, args: any, context: any) => {
      const { email, password } = args;

      if (email === "admin@test.com" && password === "admin")
        return {
          __typename: "Login",
          id: 234343,
          name: "Eric",
          email: "admin@ericgit.me",
        };

      return {
        __typename: "Error",
        error: true,
        message: "User doesn't found",
      };
    },
  },
};

const server = new ApolloServer({
  typeDefs,
  resolvers,
});

server.applyMiddleware({ app });

app.listen({ port: 3003 }, () => {
  console.log(`server runing on 3000`);
});
